package cofh.thermal.expansion.compat.jei.machine;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cofh.core.util.helpers.ItemHelper;
import cofh.lib.util.helpers.StringHelper;
import cofh.thermal.core.ThermalCore;
import cofh.thermal.core.compat.jei.TCoreJeiPlugin;
import cofh.thermal.core.util.managers.machine.SmelterRecipeManager;
import cofh.thermal.core.util.recipes.machine.SmelterRecipe;
import cofh.thermal.expansion.client.gui.machine.MachineSmelterScreen;
import cofh.thermal.lib.compat.jei.Drawables;
import cofh.thermal.lib.compat.jei.ThermalRecipeCategory;
import cofh.thermal.lib.util.recipes.ThermalRecipe;
import com.mojang.blaze3d.vertex.PoseStack;
import java.util.ArrayList;
import java.util.List;
import mezz.jei.api.gui.builder.IRecipeLayoutBuilder;
import mezz.jei.api.gui.builder.IRecipeSlotBuilder;
import mezz.jei.api.gui.drawable.IDrawable;
import mezz.jei.api.gui.drawable.IDrawableAnimated;
import mezz.jei.api.gui.ingredient.IRecipeSlotsView;
import mezz.jei.api.helpers.IGuiHelper;
import mezz.jei.api.recipe.IFocusGroup;
import mezz.jei.api.recipe.RecipeIngredientRole;
import net.minecraft.network.chat.Component;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.level.block.Block;

public class SmelterRecipeCategory extends ThermalRecipeCategory<SmelterRecipe> {
  public SmelterRecipeCategory(IGuiHelper guiHelper, ItemStack icon, ResourceLocation uid) {
    super(guiHelper, icon, uid);
    this
      
      .background = (IDrawable)guiHelper.drawableBuilder(MachineSmelterScreen.TEXTURE, 26, 11, 140, 62).addPadding(0, 0, 16, 8).build();
    this.name = (Component)StringHelper.getTextComponent(((Block)ThermalCore.BLOCKS.get("machine_smelter")).m_7705_());
    this.progressBackground = Drawables.getDrawables(guiHelper).getProgress(0);
    this.speedBackground = Drawables.getDrawables(guiHelper).getScale(4);
    this.progress = guiHelper.createAnimatedDrawable(Drawables.getDrawables(guiHelper).getProgressFill(0), 200, IDrawableAnimated.StartDirection.LEFT, false);
    this.speed = guiHelper.createAnimatedDrawable(Drawables.getDrawables(guiHelper).getScaleFill(4), 400, IDrawableAnimated.StartDirection.TOP, true);
  }
  
  public Class<? extends SmelterRecipe> getRecipeClass() {
    return SmelterRecipe.class;
  }
  
  public void setRecipe(IRecipeLayoutBuilder builder, SmelterRecipe recipe, IFocusGroup focuses) {
    List<Ingredient> inputs = recipe.getInputItems();
    List<ItemStack> outputs = new ArrayList<>(recipe.getOutputItems().size());
    List<ItemStack> catalysts = SmelterRecipeManager.instance().getCatalysts();
    for (ItemStack stack : recipe.getOutputItems())
      outputs.add(ItemHelper.cloneStack(stack)); 
    for (int i = 0; i < outputs.size(); i++) {
      float chance = ((Float)recipe.getOutputItemChances().get(i)).floatValue();
      if (chance > 1.0F)
        ((ItemStack)outputs.get(i)).m_41764_((int)chance); 
    } 
    IRecipeSlotBuilder[] inputSlots = new IRecipeSlotBuilder[3];
    IRecipeSlotBuilder[] outputSlots = new IRecipeSlotBuilder[4];
    inputSlots[0] = builder.addSlot(RecipeIngredientRole.INPUT, 43, 6);
    inputSlots[1] = builder.addSlot(RecipeIngredientRole.INPUT, 25, 6);
    inputSlots[2] = builder.addSlot(RecipeIngredientRole.INPUT, 61, 6);
    IRecipeSlotBuilder catalystSlot = builder.addSlot(RecipeIngredientRole.INPUT, 43, 42);
    int j;
    for (j = 0; j < inputs.size(); j++)
      inputSlots[j].addIngredients(inputs.get(j)); 
    if (recipe.isCatalyzable())
      ((IRecipeSlotBuilder)catalystSlot.addItemStacks(catalysts))
        .addTooltipCallback(TCoreJeiPlugin.catalystTooltip()); 
    outputSlots[0] = builder.addSlot(RecipeIngredientRole.OUTPUT, 115, 15);
    outputSlots[1] = builder.addSlot(RecipeIngredientRole.OUTPUT, 133, 15);
    outputSlots[2] = builder.addSlot(RecipeIngredientRole.OUTPUT, 115, 33);
    outputSlots[3] = builder.addSlot(RecipeIngredientRole.OUTPUT, 133, 33);
    for (j = 0; j < outputs.size(); j++)
      ((IRecipeSlotBuilder)outputSlots[j].addItemStack(outputs.get(j)))
        .addTooltipCallback(TCoreJeiPlugin.catalyzedOutputTooltip(((Float)recipe.getOutputItemChances().get(j)).floatValue(), recipe.isCatalyzable())); 
  }
  
  public void draw(SmelterRecipe recipe, IRecipeSlotsView recipeSlotsView, PoseStack matrixStack, double mouseX, double mouseY) {
    super.draw((ThermalRecipe)recipe, recipeSlotsView, matrixStack, mouseX, mouseY);
    this.progressBackground.draw(matrixStack, 84, 24);
    this.speedBackground.draw(matrixStack, 43, 24);
    this.progress.draw(matrixStack, 84, 24);
    this.speed.draw(matrixStack, 43, 24);
  }
}
